//ChangerLangue_204f.js
// 30.07.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Ce script sert  changer la langue des documents

// prparer la liste des langues
var indLangList = new Array("[No Language]", "German: Reformed", "German: Swiss", 
"German: Traditional", "English: Canadian", "English: USA", "English: USA Legal", 
"English: USA Medical", "English: UK", "Bulgarian", "Catalan", "Croatian", "Danish", 
"Spanish: Castilian", "Estonian", "Finnish", "French", "French: Canadian", "Greek", 
"Hungarian", "Italian", "Latvian", "Lithuanian", "Norwegian: Bokmal", "Norwegian: Nynorsk",
"Dutch", "Polish", "Portuguese", "Portuguese: Brazilian", "Romanian", "Russian", 
"Slovak", "Slovenian", "Swedish", "Czech", "Turkish");

var locLangList = new Array("[Aucune langue]", "Allemand : Rform", "Allemand : Suisse", 
"Allemand : Traditionnel", "Anglais : Canada", "Anglais : E.U.", "Anglais : E.U. Juridique", 
"Anglais : E.U. Mdical", "Anglais : R.U.", "Bulgare", "Catalan", "Croate", "Danois", 
"Espagnol : Castillan", "Estonien", "Finlandais", "Franais", "Franais : Canada", "Grec", 
"Hongrois", "Italien", "Letton", "Lituanien", "Norvgien : Bokml", "Norvgien : Nynorsk", 
"Nerlandais", "Polonais", "Portugais", "Portugais : Brsilien", "Roumain", "Russe", 
"Slovaque", "Slovne", "Sudois", "Tchque", "Turc");

// lire le fichier qui contient la langue appliqu la dernire fois
var curLang = 0;
var f = new File("\/Temporary Items\/curLang.txt");
fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		curLang = (f.read())*1;
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}
//Effacer des dialogues qui sont ventuellement rests dans la mmoire
var numDialogs = app.dialogs.length;
if (numDialogs > 0){
	for (var ctr=0; ctr < numDialogs; ctr++){
		app.dialogs.item(0).destroy();
	}
}

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert (sinon: montrer un dialogue)
var nDocs = app.documents.length;
if (nDocs == 0) {
	var folderObj = File (Folder.selectDialog("Slectionner le dossier contenant les documents InDesign."));
	var testObj = "" + folderObj;
	if (testObj.match("null")) {
		exit();
	}
	// appeler la sous-routine qui montre le dialogue avec le choix des langues
	var newLang = askUser();
	// dsactiver les messages ventuels causs par des polices et des images manquants
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
	// dresser une liste du contanu du dossier
	var allFiles = folderObj.getFiles();
	
	// une boucle  travers les fichiers
	for (var i=0; i<allFiles.length; i++) {
		var curName = allFiles[i].name;
		if (curName.match(".indd")) {
			try {
				// ouvrir le document actuel
				app.open(File (allFiles[i]));
				changeLanguage(newLang);
				app.activeDocument.close(SaveOptions.yes);
			}
			catch (e) {
			}
		}
	}
	// activer les messages
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
}
else {
	var newLang = askUser();
	var docRef = new Array ();
	for (var i=0; i<nDocs; i++) {
		docRef.push(app.documents[i].name);
	}
	var okay = true;
	for (var i=0; i<docRef.length; i++) {
		app.activeDocument = app.documents.item(docRef[i]);
		if (nDocs>1 && i>0) {
			var okay = confirm ("Changer la langue de ce document?\n\nConfirmer par un clic sur \"Yes\".");
		}
		if (okay) {
			changeLanguage(newLang);
		}
	}
	app.activeDocument = app.documents.item(docRef[0]);
}

alert ("C'est fait.");

// la fonction qui permet de slectionner la nouvelle langue
function askUser() {
	// einen Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"Modifier la langue", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"La nouvelle langue:", minWidth:80});
				staticTexts.add({staticLabel:"", minWidth:20});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var langName = dropdowns.add({stringList:locLangList, selectedIndex:curLang, minWidth:130});
				}
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"", minWidth:4});
			}
		}
	}
	
	// afficher le dialogue et mmoriser le choix de l'utilisateur
	if (aDialog.show() == true) {
		var langID = langName.selectedIndex;
		var newLang = (indLangList[langID]);
		aDialog.destroy();
	}
	else {
		aDialog.destroy();
		exit();
	}
	
	// crire le numro de la langue dans le fichier
	var f = new File("\/Temporary Items\/curLang.txt");
	fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(langID);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return newLang;
}

// la fonction qui procde  la modification de la langue
function changeLanguage(newLang) {
	// changer la langue des feuilles de style de paragraphes
	nParaStyles = app.documents[0].paragraphStyles.length;
	for (var i=0; i<nParaStyles; i++) {
		try {
			var curLang = app.documents[0].paragraphStyles[i].appliedLanguage.name;
			if (curLang != "[No Language]") {
				app.documents[0].paragraphStyles[i].appliedLanguage = newLang;
			}
		}
		catch (e) {
		}
	}
	
	// changer la langue des feuilles de style de caractres
	nCharStyles = app.documents[0].characterStyles.length;
	for (var i=0; i<nCharStyles; i++) {
		try {
			var curLang = app.documents[0].characterStyles[i].appliedLanguage.name;
			if (curLang != "[No Language]") {
				app.documents[0].characterStyles[i].appliedLanguage = newLang;
			}
		}
		catch (e) {
		}
	}
	
	// modifier la langue des textes, afin de ne pas oublier ceux sans feuille de style
	app.documents[0].stories.everyItem().appliedLanguage = newLang;
	// traiter galement les tableaux...
	try {
		app.documents[0].stories.everyItem().tables.everyItem().cells.everyItem().texts[0].appliedLanguage = newLang;
	}
	catch (e) {
	}
}